SystemOrganization addCategory: #'LookEnhancements-Extra'!

!MenuMorph class methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/24/2005 20:09'!
closeBoxImage
	"Supplied here because we don't necessarily have ComicBold"

	CloseBoxImage ifNil: 
		[CloseBoxImage _ (Form
			extent: 10@16
			depth: 2
			fromArray: #( 0 0 0 0 1342259200 1409630208 353697792 89391104 22020096 89391104 353697792 1409630208 1342259200 0 0 0)
			offset: 0@0)].
	^ Preferences inverteBright
		ifTrue: [ CloseBoxImage deepCopy mapColor: Color black to: Color white; yourself ]
		ifFalse: [ CloseBoxImage ]! !

!MenuMorph class methodsFor: '*LookEnhancements' stamp: 'jrp 11/3/2004 12:05'!
initialize

	"MenuMorph initialize"
	
	Preferences
		setParameter: #menuTitleBorderWidth to: 0;
		setParameter: #menuTitleColor to: (TranslucentColor r: 0.87 g: 0.8 b: 1 alpha: 0.65);
		setParameter: #menuColor to: (Color 
			r: (215/255) asFloat 
			g: (220/255) asFloat 
			b: (232/255) asFloat)
! !

!MenuMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 6/19/2005 20:54'!
addStayUpIcons
	| title closeBox pinBox titleBarArea titleString |
	title _ submorphs
				detect: [:ea | ea hasProperty: #titleString]
				ifNone: [self setProperty: #needsTitlebarWidgets toValue: true.
					^ self].
	closeBox _ IconicButton new target: self;
				 actionSelector: #delete;
				 labelGraphic: self class closeBoxImage;
				 color: Color transparent;
				 extent: 14 @ 16;
				 borderWidth: 0.
	pinBox _ IconicButton new target: self;
				 actionSelector: #stayUp:;
				 arguments: {true};
				 labelGraphic: self class pushPinImage;
				 color: Color transparent;
				 extent: 14 @ 15;
				 borderWidth: 0.
	Preferences noviceMode
		ifTrue: [closeBox setBalloonText: 'close this menu'.
			pinBox setBalloonText: 'keep this menu up'].
	titleBarArea _  AlignmentMorph newRow vResizing: #shrinkWrap;
			 layoutInset: 3;
			 color: Preferences menuTitleColor;
			 addMorphBack: closeBox;
			 addMorphBack: title;
			 addMorphBack: pinBox.
	
	title color: Color transparent.

	titleString _ title 
		findDeepSubmorphThat: [:each | each respondsTo: #font: ]
		ifAbsent: [nil].
	titleString font: Preferences windowTitleFont.
	Preferences roundedMenuCorners
		ifTrue: [titleBarArea useRoundedCorners].
	
	self addMorphFront: titleBarArea.
	titleBarArea setProperty: #titleString toValue: (title valueOfProperty: #titleString).
	title removeProperty: #titleString.
	self setProperty: #hasTitlebarWidgets toValue: true.
	self removeProperty: #needsTitlebarWidgets.
	self removeStayUpItems! !

!MenuMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 10/23/2004 15:10'!
addTitle: aString updatingSelector: aSelector updateTarget: aTarget 
	"Add a title line at the top of this menu Make aString its initial 
	contents.  
	If aSelector is not nil, then periodically obtain fresh values for its 
	contents by sending aSelector to aTarget.."
	| title |
	title _ AlignmentMorph new.
	self setTitleParametersFor: title.
	title vResizing: #shrinkWrap.
	title listDirection: #topToBottom.
	title wrapCentering: #center;
		 cellPositioning: #topCenter;

		 layoutInset: 0.
	aSelector
		ifNil: [(aString asString findTokens: String cr)
				do: [:line | title addMorphBack: (StringMorph new contents: line;
							 font: Preferences windowTitleFont)]]
		ifNotNil: [title addMorphBack: (UpdatingStringMorph new lock; font: Preferences windowTitleFont; useStringFormat; target: aTarget; getSelector: aSelector)].
	title setProperty: #titleString toValue: aString.
	self addMorphFront: title.
	(self hasProperty: #needsTitlebarWidgets)
		ifTrue: [self addStayUpIcons]! !

!MenuMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 20:32'!
initialize
	super initialize.
	bounds _ 0@0 corner: 40@10.
	self setDefaultParameters.
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	defaultTarget _ nil.
	selectedItem _ nil.
	stayUp _ false.
	popUpOwner _ nil.
	Preferences roundedMenuCorners ifTrue: [self useRoundedCorners].
	self borderStyle: BorderStyle thinGray.
	self addDropShadow;
		shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
		shadowOffset: 1@1
! !

!MenuMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/19/2005 17:18'!
setDefaultParameters
	| colorFromMenu worldColor menuColor menuBorderColor |
	colorFromMenu := Preferences menuColorFromWorld
				and: [Display depth > 4]
				and: [(worldColor := self currentWorld color) isColor].
	""
	menuColor := colorFromMenu
				ifTrue: [worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.85 with: Preferences defaultBackgroundColor]
						ifFalse: [worldColor mixed: 0.4 with: Preferences defaultBackgroundColor]]
				ifFalse: [Preferences inverteBright
						ifTrue: 
							[ |c|
							c _ Preferences menuColor.
							Color r: 1.0-c red g: 1.0-c green b: 1.0-c blue]
						ifFalse: [Preferences menuColor]].
	""
	menuBorderColor := Preferences menuAppearance3d
				ifTrue: [#raised]
				ifFalse: [colorFromMenu
						ifTrue: [worldColor muchDarker]
						ifFalse: [Preferences menuBorderColor]].
	""
	self
		setColor: menuColor
		borderWidth: Preferences menuBorderWidth
		borderColor: menuBorderColor.
	""
	self layoutInset: 3! !

!MenuMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 10/23/2004 15:13'!
setTitleParametersFor: aMenuTitle 
	| menuTitleColor menuTitleBorderColor |
	Preferences roundedMenuCorners
		ifTrue: [aMenuTitle useRoundedCorners].
	""
	menuTitleColor _ Preferences menuColorFromWorld
				ifTrue: [self color darker]
				ifFalse: [Preferences menuTitleColor].
	""
	menuTitleBorderColor _ Preferences menuAppearance3d
				ifTrue: [#inset]
				ifFalse: [Preferences menuColorFromWorld
						ifTrue: [self color darker muchDarker]
						ifFalse: [Preferences menuTitleBorderColor]].
	""
	aMenuTitle
		setColor: menuTitleColor
		borderWidth: Preferences menuTitleBorderWidth
		borderColor: menuTitleBorderColor! !

!MenuMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/19/2005 16:50'!
updateColor
	| fill title |
	Preferences gradientMenu
		ifFalse: [^ self].
	""
	fill _ GradientFillStyle ramp: {0.0 -> Preferences defaultBackgroundColor. 1 -> self color}.
	""
	fill
		radial: false;
		origin: self topLeft;
		direction: 0 @ self height.
	""
	self fillStyle: fill.
	" 
	update the title color"
	title _ self allMorphs
				detect: [:each | each hasProperty: #titleString]
				ifNone: [^ self].
	""
	fill _ GradientFillStyle ramp: {0.0 -> title color twiceLighter. 1 -> title color twiceDarker}.
	""
	fill
		origin: title topLeft;
		direction: title width @ 0.
	""
	title fillStyle: fill! !

!MailComposition methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:06'!
openInMorphic
	"open an interface for sending a mail message with the given initial 
	text "
	| textMorph buttonsList sendButton attachmentButton |
	morphicWindow _ SystemWindow labelled: 'Mister Postman'.
	morphicWindow model: self.
	textEditor _ textMorph _ PluggableTextMorph
						on: self
						text: #messageText
						accept: #messageText:.
	morphicWindow addMorph: textMorph frame: (0 @ 0.1 corner: 1 @ 1).
	buttonsList _ AlignmentMorph newRow.
	sendButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #submit.
	sendButton
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		label: 'send message';
		setBalloonText: 'add this to the queue of messages to be sent';
		onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.
	buttonsList addMorphBack: sendButton.
	
	attachmentButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #addAttachment.
	attachmentButton
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		label: 'add attachment';
		setBalloonText: 'Send a file with the message';
		onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.
	buttonsList addMorphBack: attachmentButton.
	
	morphicWindow addMorph: buttonsList frame: (0 @ 0 extent: 1 @ 0.1).
	morphicWindow openInMVC! !

!ChangeList methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:14'!
optionalButtonRow
	"Answer a row of buttons to occur in a tool pane"

	| aRow aButton |
	aRow _ AlignmentMorph newRow.
	aRow hResizing: #spaceFill.
	aRow clipSubmorphs: true.
	aRow layoutInset: 2@2; cellInset: 3.
	aRow wrapCentering: #center; cellPositioning: #leftCenter.
	self changeListButtonSpecs do:
		[:triplet |
			aButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: triplet second.
			aButton
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				borderStyle: BorderStyle thinGray;
				label: triplet first asString;
				askBeforeChanging: true;
				onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.

			aRow addMorphBack: aButton.
			aButton setBalloonText: triplet third].
	aRow addMorphBack: self regularDiffButton.
	self wantsPrettyDiffOption ifTrue:
		[aRow addMorphBack: self prettyDiffButton].
	^ aRow! !

!TextMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:09'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Preferences defaultTextColor! !

!SystemProgressMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 21:22'!
setDefaultParameters
	"change the receiver's appareance parameters"
	| colorFromMenu worldColor menuColor |
	colorFromMenu _ Preferences menuColorFromWorld
				and: [Display depth > 4]
				and: [(worldColor _ self currentWorld color) isColor].
	menuColor _ colorFromMenu
				ifTrue: [worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.85 with: Color black]
						ifFalse: [worldColor mixed: 0.4 with: Color white]]
				ifFalse: [Preferences menuColor].

	Preferences roundedMenuCorners
		ifTrue: [self useRoundedCorners].

	self color: menuColor.
	self borderStyle: BorderStyle thinGray.
	self addDropShadow;
		shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
		shadowOffset: 1@1.

	self
		updateColor: self
		color: self color
		intensity: 1.! !

!SystemProgressMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 21:45'!
updateColor: aMorph color: aColor intensity: anInteger 
	"update the apareance of aMorph"
	| fill |
	Preferences gradientMenu
		ifFalse: [^ self].

	fill _ GradientFillStyle ramp: {0.0 -> Color white. 1 ->aColor}.
	fill radial: false;
		origin: aMorph topLeft;
		direction: 0 @ aMorph height.
	aMorph fillStyle: fill! !

!MCSnapshotBrowser methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:05'!
buttonWithState: getState action: action label: buttonLabel
	^ (PluggableButtonMorph on: self getState: getState action: action)
			label: buttonLabel;
			onColor: Color gray
			offColor: Preferences defaultBackgroundColor ;
			borderWidth: 0;
			borderRaised;
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!MenuItemMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/24/2005 20:00'!
drawOn: aCanvas 
	| stringBounds leftEdge |
	isSelected & isEnabled
		ifTrue: [ aCanvas fillRectangle: self bounds fillStyle: self selectionFillStyle ].

	leftEdge := 0.
	self hasIcon
		ifTrue: [| iconForm | 
			iconForm := isEnabled ifTrue:[self icon] ifFalse:[self icon asGrayScale].
			aCanvas paintImage: iconForm at: self left @ (self top + (self height - iconForm height // 2)).
			leftEdge := iconForm width + 2].

	self hasMarker
		ifTrue: [ leftEdge := leftEdge + self submorphBounds width + 8 ].

	stringBounds := bounds left: bounds left + leftEdge.

	aCanvas
		drawString: contents
		in: stringBounds
		font: self fontToUse
		color: color.
	subMenu
		ifNotNil: [aCanvas paintImage: SubMenuMarker at: self right - 8 @ (self top + self bottom - SubMenuMarker height // 2)]! !

!MenuItemMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:00'!
isEnabled: aBoolean

	isEnabled = aBoolean ifTrue: [^ self].
	isEnabled _ aBoolean.
	self color: 
		(aBoolean
			ifTrue: [ Preferences defaultTextColor ]
			ifFalse: [ Color lightGray ]).! !

!MenuItemMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/21/2005 17:26'!
selectionFillStyle
	"answer the fill style to use with the receiver is the selected  
	element"
	| fill baseColor preferenced |
	Display depth <= 2
		ifTrue: [^ Color gray].

	preferenced := Preferences textHighlightColor.
	preferenced notNil ifTrue:[^ preferenced].

	baseColor := owner color negated.
	Preferences gradientMenu
		ifFalse: [^ baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceLighter . 1 -> baseColor twiceDarker}.
	fill origin: self topLeft.
	fill direction: self width @ 0.
	^ fill! !

!Lexicon methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:17'!
customButtonRow
	"Answer a custom row of widgets, which pertain primarily to within-tool navigation"

	| aRow aButton aLabel |
	aRow _ AlignmentMorph newRow.
	aRow setNameTo: 'navigation controls'.
	aRow beSticky.
	aRow hResizing: #spaceFill.
	aRow wrapCentering: #center; cellPositioning: #leftCenter.
	aRow clipSubmorphs: true.
	aRow cellInset: 3.

	self customButtonSpecs  do:
		[:triplet |
			aButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: triplet second.
			aButton 
				useRoundedCorners;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				onColor: Color gray offColor: Color gray.
			aLabel _ Preferences abbreviatedBrowserButtons 
				ifTrue: [self abbreviatedWordingFor: triplet second]
				ifFalse: [nil].
			aButton label: (aLabel ifNil: [triplet first asString])
				" font: (StrikeFont familyName: 'Atlanta' size: 9)".
			triplet size > 2 ifTrue: [aButton setBalloonText: triplet third].
			triplet size > 3 ifTrue: [aButton triggerOnMouseDown: triplet fourth].
			aRow addMorphBack: aButton].

	aRow addMorphBack: self homeCategoryButton.
	aRow addMorphFront: (Morph new extent: (4@10)) beTransparent.
	aRow addMorphFront: self mostGenericButton.
	aRow addMorphFront: self menuButton.

	^ aRow! !

Object subclass: #LookEnhancementPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LookEnhancements-Extra'!

!LookEnhancementPreferences class methodsFor: 'as yet unclassified' stamp: 'cmm 7/24/2005 20:15'!
initialize

	Preferences setParameter: #menuColor to: Color lightGray muchLighter.
	Preferences setPreference: #alternativeWindowBoxesLook toValue: false.
	Preferences setPreference: #gradientMenu toValue: true.
	Preferences
		addPreference: #invertBright
		category: #windows
		default: false
		balloonHelp: 'When true, the brightness of Squeak will be reduced.  Windows and menus will show white text on black backgrounds, which may be preferable in low-light environments.  This feature only works with the alternativeWindowLook.'.
	Preferences
		parameterAt: #menuSelectionColor
		ifAbsentPut: Preferences textHighlightColor.
	"Wasn't sure how to do this with stock Monticello"
	SystemWindow removeSelector: #borderWidthForRounding.
	SystemProgressMorph reset.
	self showReadme! !

!LookEnhancementPreferences class methodsFor: 'as yet unclassified' stamp: 'jrp 7/22/2005 22:01'!
showReadme

'Look Enhancements  (20050722)

A few notes:

While making many visual changes to the look and feel of windows and buttons, this package also adds some window preferences that modify the behavior of this enhancement, specifically in the area of resizing panes and windows.

The new preferences are accessible via the Preferences panel. The Preferences panel is accessible via the World menu (appearance | preferences) or by running the following code: Preferences openFactoredPanel.

The preferences added are as follows:

1. showSplitterHandles (default is on) - When this feature is turned on it will show handles on the splitter between panes. Resizing the panes will require you to grab the handles. If not enabled then the entire splitter can be used to resize and no handles will be displayed.

2. fastSplitterResize (default is off) - When this feature is turned on it will speed up the resizing of panes when using the splitter by eliminating the animation of pane size modifications.

3. resizeOnAllSides (default is off) - When this feature is turned on it will allow windows to be resized on on sides. If not enabled then the resizing of windows will only be accessible from the bottom right corner.
' openInWorkspaceWithTitle: 'Look Enhancements Readme'! !

!LookEnhancementPreferences methodsFor: 'as yet unclassified' stamp: 'jrp 7/6/2005 21:46'!
seeClassSide! !

!LazyListMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 22:58'!
colorForRow: 	row
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ Preferences defaultTextColor ]
		ifFalse: [ self color ].! !

!LazyListMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:51'!
drawBackgroundForMulti: row on: aCanvas
	| selectionDrawBounds |
	"shade the background darker, if this row is selected"

	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas 
		fillRectangle: selectionDrawBounds 
		color: Preferences textHighlightColor! !

!LazyListMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:58'!
drawSelectionOn: aCanvas
	| selectionDrawBounds |
	selectedRow ifNil: [ ^self ].
	selectedRow = 0 ifTrue: [ ^self ].
	selectionDrawBounds := self drawBoundsForRow: selectedRow.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas fillRectangle: selectionDrawBounds color: Preferences textHighlightColor! !

!SystemWindow class methodsFor: '*LookEnhancements' stamp: 'jrp 7/22/2005 21:07'!
resizeOnAllSides
	
	^ Preferences valueOfPreference: #resizeOnAllSides ifAbsent: [false]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/16/2004 11:13'!
addCloseBox
	"If I have a labelArea, add a close box to it"
	| frame |
	labelArea
		ifNil: [^ self].
	closeBox := self createCloseBox.
	frame := LayoutFrame new.
	frame leftFraction: 0;
		 leftOffset: 2;
		 topFraction: 0;
		 topOffset: 0.
	closeBox layoutFrame: frame.
	labelArea addMorphBack: closeBox! !

!SystemWindow methodsFor: '*LookEnhancements' stamp: 'bvs 3/24/2004 15:19'!
addCornerGrip

	| grip |
	grip _ CornerGripMorph new target: self.
	grip position: self bounds corner - grip extent.
	
	grip layoutFrame: (LayoutFrame
		fractions: (1@1 corner: 1@1) 
		offsets: (-23@-23 corner: 0@0)).
	
	self addMorphBack: grip.! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/16/2004 11:13'!
addExpandBox
	"If I have a labelArea, add a close box to it"
	| frame |
	labelArea
		ifNil: [^ self].
	expandBox := self createExpandBox.
	frame := LayoutFrame new.
	frame leftFraction: 1;
		 leftOffset: (self boxExtent x * 2 + 3) negated;
		 topFraction: 0;
		 topOffset: 0.
	expandBox layoutFrame: frame.
	labelArea addMorphBack: expandBox! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/16/2004 11:13'!
addMenuControl
	"If I have a label area, add a menu control to it."
	| frame |
	labelArea
		ifNil: [^ self].
	"No menu if no label area"
	menuBox
		ifNotNil: [menuBox delete].
	menuBox := self createMenuBox.
	frame := LayoutFrame new.
	frame leftFraction: 0;
		 leftOffset: closeBox right + 3;
		 topFraction: 0;
		 topOffset: 0.
	menuBox layoutFrame: frame.
	labelArea addMorphBack: menuBox! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 22:41'!
addMorph: aMorph fullFrame: aLayoutFrame

	| left right bottom top |
	left _ aLayoutFrame leftOffset ifNil: [0].
	right _ aLayoutFrame rightOffset ifNil: [0].
	bottom _ aLayoutFrame bottomOffset ifNil: [0].
	top _ aLayoutFrame topOffset ifNil: [0].
	
	aLayoutFrame rightFraction = 1 ifTrue: [aLayoutFrame rightOffset: right - 6].
	aLayoutFrame leftFraction = 0
		ifTrue: [aLayoutFrame leftOffset: left + 6]
		ifFalse: [aLayoutFrame leftOffset: left + 4].

	aLayoutFrame bottomFraction = 1 ifTrue: [aLayoutFrame bottomOffset: bottom - 6].
	aLayoutFrame topFraction = 0
		ifTrue: [aLayoutFrame topOffset: top]
		ifFalse: [aLayoutFrame topOffset: top + 4].
	
	(aMorph class name = #BrowserCommentTextMorph) ifTrue:
		[aLayoutFrame rightOffset: -6.
		aLayoutFrame leftOffset: 6.
		aLayoutFrame bottomOffset: -6.
		aLayoutFrame topOffset: -2].
	
	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs _ paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	Preferences alternativeWindowLook
		ifFalse:
			[aMorph borderWidth: 1.
			aMorph color: self paneColor]
		ifTrue:
			[aMorph adoptPaneColor: self paneColor.
			aMorph borderWidth: 1; borderColor: Color lightGray; color: self alternativePaneColor ].
	Preferences scrollBarsOnRight	"reorder panes so flop-out right-side scrollbar is visible"
		ifTrue: [self addMorphBack: aMorph].
		
	self addPaneSplitters.! !

!SystemWindow methodsFor: '*LookEnhancements' stamp: 'cmm 7/21/2005 16:56'!
addPaneSplitters

	| splitters rightSplitter remainingRight remainingBottom target targetX sameX minY maxY targetY sameY minX maxX bottomSplitter |
	remainingRight _ paneMorphs copy reject: [:each | each layoutFrame rightFraction = 1].
	remainingBottom _ paneMorphs copy reject: [:each | each layoutFrame bottomFraction = 1].
	
	self removePaneSplitters.
		
"	self addCornerGrip."

	[remainingRight size > 0] whileTrue:
		[target _ remainingRight first.
		targetX _ target layoutFrame rightFraction.
		sameX _ paneMorphs select: [:each | each layoutFrame rightFraction = targetX].
		minY _ (sameX detectMin: [:each | each layoutFrame topFraction]) layoutFrame topFraction.
		maxY _ (sameX detectMax: [:each | each layoutFrame bottomFraction]) layoutFrame bottomFraction.
			
		rightSplitter _ ProportionalSplitterMorph new.
		rightSplitter layoutFrame: (LayoutFrame
			fractions: (targetX @ minY corner: (targetX @ maxY))
			offsets: ((0 @ (target layoutFrame topOffset ifNil: [0]) corner: (4 @ (target layoutFrame bottomOffset ifNil: [0]))) translateBy: (target layoutFrame rightOffset ifNil: [0]) @ 0)).
		self addMorphBack: rightSplitter.
		
		remainingRight _ remainingRight copyWithoutAll: sameX].

	[remainingBottom size > 0] whileTrue:
		[target _ remainingBottom first.
		targetY _ target layoutFrame bottomFraction.
		sameY _ paneMorphs select: [:each | each layoutFrame bottomFraction = targetY].
		minX _ (sameY detectMin: [:each | each layoutFrame leftFraction]) layoutFrame leftFraction.
		maxX _ (sameY detectMax: [:each | each layoutFrame rightFraction]) layoutFrame rightFraction.
		
		bottomSplitter _ ProportionalSplitterMorph new.
		bottomSplitter beSplitsTopAndBottom.

		bottomSplitter layoutFrame: (LayoutFrame
			fractions: (minX @ targetY corner: (maxX @ targetY))
			offsets: (((target layoutFrame leftOffset ifNil: [0]) @ 0 corner: ((target layoutFrame rightOffset ifNil: [0]) @ 4)) translateBy: 0 @ (target layoutFrame bottomOffset ifNil: [0]))).
				
		self addMorphBack: bottomSplitter.
		
		remainingBottom _ remainingBottom copyWithoutAll: sameY].
	
	splitters _ self submorphsSatisfying: [:each | each isKindOf: ProportionalSplitterMorph].
	splitters do:
		[:each |
		each splitsTopAndBottom
			ifTrue:
				[self submorphsDo:
					[:eachMorph |
					(eachMorph ~= each and: [eachMorph layoutFrame bottomFraction = each layoutFrame topFraction]) ifTrue: [each addLeftOrTop: eachMorph].
					(eachMorph ~= each and: [eachMorph layoutFrame topFraction = each layoutFrame bottomFraction]) ifTrue: [each addRightOrBottom: eachMorph]]]
			ifFalse:
				[self submorphsDo:
					[:eachMorph |
					(eachMorph ~= each and: [eachMorph layoutFrame rightFraction = each layoutFrame leftFraction]) ifTrue: [each addLeftOrTop: eachMorph].
					(eachMorph ~= each and: [eachMorph layoutFrame leftFraction = each layoutFrame rightFraction]) ifTrue: [each addRightOrBottom: eachMorph]]]].
		! !

!SystemWindow methodsFor: '*LookEnhancements' stamp: 'cmm 7/19/2005 17:18'!
alternativePaneColor

	^ Preferences inverteBright
		ifTrue: [ Color black ]
		ifFalse: [ Color white ]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 4/2/2004 16:51'!
collapseOrExpand
	"Collapse or expand the window, depending on existing state"
	| cf |
	isCollapsed
		ifTrue: 
			["Expand -- restore panes to morphics structure"
			isCollapsed _ false.
			self activate.  "Bring to frint first"
			Preferences collapseWindowsInPlace
				ifTrue: 
					[fullFrame := fullFrame align: fullFrame topLeft with: self getBoundsWithFlex topLeft]
				ifFalse:
					[collapsedFrame _ self getBoundsWithFlex].
			collapseBox ifNotNil: [collapseBox setBalloonText: 'collapse this window'].
			self setBoundsWithFlex: fullFrame.
			paneMorphs reverseDo: 
					[:m |  self addMorph: m unlock.
					self world startSteppingSubmorphsOf: m].
			self addPaneSplitters]
		ifFalse: 
			["Collapse -- remove panes from morphics structure"
			isCollapsed _ true.
			fullFrame _ self getBoundsWithFlex.
			"First save latest fullFrame"
			paneMorphs do: [:m | m delete; releaseCachedState].
			self removePaneSplitters.
			model modelSleep.
			cf := self getCollapsedFrame.
			(collapsedFrame isNil and: [Preferences collapseWindowsInPlace not]) ifTrue:
				[collapsedFrame _ cf].
			self setBoundsWithFlex: cf.
			collapseBox ifNotNil: [collapseBox setBalloonText: 'expand this window'].
			expandBox ifNotNil: [expandBox setBalloonText: 'expand to full screen']].
	self layoutChanged! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 16:23'!
createCloseBox
	| image |
	Preferences inverteBright
		ifTrue:
			[ image _ self class closeBoxImage deepCopy.
			image mapColor: Color black to: Color white ]
		ifFalse:
			[ image _ self class closeBoxImage ].
	^ self createBox labelGraphic: image;
		 extent: self boxExtent;
		 actionSelector: #closeBoxHit;
		 setBalloonText: 'close this window' translated! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/16/2004 11:12'!
extent: aPoint 
	"Set the receiver's extent to value provided. Respect my minimumExtent."

	| newExtent |
	newExtent _ self isCollapsed
		ifTrue: [aPoint]
		ifFalse: [aPoint max: self minimumExtent].
	newExtent = self extent ifTrue: [^ self].

	isCollapsed
		ifTrue: [super extent: newExtent x @ (self labelHeight + 2)]
		ifFalse: [super extent: newExtent].
	isCollapsed
		ifTrue: [collapsedFrame _ self bounds]
		ifFalse: [fullFrame _ self bounds]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 4/2/2004 16:55'!
getRawLabel
	| contentsFit |
	contentsFit _ label duplicate fitContents.
	contentsFit extent: (label extent x min: contentsFit extent x) @ contentsFit extent y.
	
	^ contentsFit
! !

!SystemWindow methodsFor: '*LookEnhancements' stamp: 'cmm 7/20/2005 16:28'!
gradientWithColor: aColor

	| ramp |
	ramp _ {0.0 -> Preferences defaultBackgroundColor. 1.0 -> aColor}.

	^ (GradientFillStyle ramp: ramp)
		radial: true;
		origin: self bounds origin;
		direction: 0 @ 223;
		normal: 223 @ 0.! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 10:52'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	super initialize.
	allowReframeHandles _ true.
	labelString
		ifNil: [labelString _ 'Untitled Window'].
	isCollapsed _ false.
	activeOnlyOnTop _ true.
	paneMorphs _ Array new.
	Preferences alternativeWindowLook
		ifTrue: [""
			borderColor _ Color lightGray.
			borderWidth _ 1.
			self color: Color lightGray lighter lighter lighter]
		ifFalse: [""
			borderColor _ Color black.
			borderWidth _ 1.
			color _ Color black].
	self layoutPolicy: ProportionalLayout new.
	self wantsLabel
		ifTrue: [""label _ StringMorph new contents: labelString;
						 font: Preferences windowTitleFont emphasis: 1.
			"Add collapse box so #labelHeight will work"
			collapseBox _ self createCollapseBox.
			stripes _ Array
						with: (RectangleMorph newBounds: bounds)
						with: (RectangleMorph newBounds: bounds).
			"see extent:"
			self addLabelArea.
			self setLabelWidgetAllowance.
			self addCloseBox.
			self addMenuControl.
			labelArea addMorphBack: (Morph new extent: 6 @ 0).
			labelArea addMorphBack: label.
			self wantsExpandBox
				ifTrue: [self addExpandBox].
			labelArea addMorphBack: collapseBox.
			self setFramesForLabelArea.
			Preferences clickOnLabelToEdit
				ifTrue: [label
						on: #mouseDown
						send: #relabel
						to: self].
			Preferences noviceMode
				ifTrue: [closeBox
						ifNotNil: [closeBox setBalloonText: 'close window'].
					menuBox
						ifNotNil: [menuBox setBalloonText: 'window menu'].
					collapseBox
						ifNotNil: [collapseBox setBalloonText: 'collapse/expand window']]].
				
	self addCornerGrip.
	
	self
		on: #mouseEnter
		send: #spawnReframeHandle:
		to: self.
	self
		on: #mouseLeave
		send: #spawnReframeHandle:
		to: self.
	self extent: 300 @ 200.
	mustNotClose _ false.
	updatablePanes _ Array new.
	self addDropShadow;
		shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
		shadowOffset: 1@1.! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/21/2005 23:02'!
labelHeight
	"Answer the height for the window label.  The standard behavior is at bottom; a hook is provided so that models can stipulate other heights, in support of various less-window-looking demos."

	| aHeight |
	(model notNil and: [model respondsTo: #desiredWindowLabelHeightIn:]) ifTrue:
		[(aHeight _ model desiredWindowLabelHeightIn: self) ifNotNil: [^ aHeight]].

	^ label ifNil: [0] ifNotNil:
		 [(label height + 10) max:
			(collapseBox ifNotNil: [collapseBox height] ifNil: [10])]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bmk 3/19/2002 02:11'!
mouseMove: evt
	"Handle a mouse-move event"

	| cp |
	cp _ evt cursorPoint.
	self valueOfProperty: #clickPoint ifPresentDo: 
		[:firstClick |
		((self labelRect containsPoint: firstClick) and: [(cp dist: firstClick) > 3]) ifTrue:
		["If this is a drag that started in the title bar, then pick me up"
		^ self isSticky ifFalse:
			[self fastFramingOn 
				ifTrue: [self doFastFrameDrag: firstClick]
				ifFalse: [evt hand grabMorph: self topRendererOrSelf]]]].
	model windowActiveOnFirstClick ifTrue:
		["Normally window takes control on first click.
		Need explicit transmission for first-click activity."
		submorphs do: [:m | (m containsPoint: cp) ifTrue: [m mouseMove: evt]]]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/19/2005 17:10'!
paneColorToUse
	^ Display depth <= 2
		ifTrue:
			[Preferences defaultBackgroundColor]
		ifFalse:
			[self paneColor]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/17/2004 09:15'!
paneColor: aColor
	self setProperty: #paneColor toValue: aColor.

	self adoptPaneColor: aColor.! !

!SystemWindow methodsFor: '*LookEnhancements' stamp: 'bvs 4/2/2004 16:49'!
removePaneSplitters

	| splitters corners |
	splitters _ self submorphsSatisfying: [:each | each isKindOf: ProportionalSplitterMorph].
	splitters do: [:each | each delete].
	
	corners _ self submorphsSatisfying: [:each | each isKindOf: CornerGripMorph].
	corners do: [:each | each delete].
! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/16/2004 12:22'!
setFramesForLabelArea
	"an aid to converting old instances, but then I found  
	convertAlignment (jesse welton's note)"
	| frame |
	labelArea
		ifNil: [^ self].
		
	labelArea
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		layoutInset: 0.
	label hResizing: #spaceFill.
	
	labelArea
		ifNotNil: [frame := LayoutFrame new.
			frame leftFraction: 0;
				 topFraction: 0;
				 rightFraction: 1;
				 topOffset: self labelHeight negated.
			Preferences alternativeWindowLook
				ifTrue: [frame leftOffset: 6;
						 rightOffset: -6;
						 topOffset: self labelHeight negated + 6;
						 bottomOffset: -6].
			labelArea layoutFrame: frame]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/2/2005 22:18'!
setStripeColorsFrom: paneColor 
	"Set the stripe color based on the given paneColor"

	labelArea ifNotNil: 
			[""

			labelArea color: (Preferences alternativeWindowLook 
						ifTrue: [Color transparent]
						ifFalse: [Color transparent])].
	""
	self updateBoxesColor: (self isActive 
				ifTrue: [paneColor]
				ifFalse: [paneColor muchDarker]).
	""
	stripes ifNil: [^self].
	""
	Preferences alternativeWindowLook 
		ifTrue: 
			[""

			self isActive 
				ifTrue: 
					[""

					self fillStyle: (self gradientWithColor: paneColor lighter lighter lighter)]
				ifFalse: 
					["This could be much faster"

					self fillStyle: (self gradientWithColor: paneColor duller)]]
		ifFalse: 
			[""

			self isActive 
				ifTrue: 
					[""

					(stripes second)
						color: paneColor;
						borderColor: stripes second color darker.
					(stripes first)
						color: stripes second borderColor darker;
						borderColor: stripes first color darker]
				ifFalse: 
					["This could be much faster"

					(stripes second)
						color: paneColor;
						borderColor: paneColor.
					(stripes first)
						color: paneColor;
						borderColor: paneColor]]! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'bvs 3/24/2004 15:27'!
spawnPaneFrameHandle: event 
	| resizer localPt side growingPane newBounds adjoiningPanes limit cursor |
	true ifTrue: [^ self]. "Working on new resizers"
	
	(self world firstSubmorph isKindOf: NewHandleMorph) 
		ifTrue: [^self	"Prevent multiple handles"].
	((self innerBounds withHeight: self labelHeight + 4) 
		containsPoint: event cursorPoint) 
			ifTrue: [^self	"in label or top of top pane"].
	growingPane := self paneWithLongestSide: [:s | side := s]
				near: event cursorPoint.
	growingPane ifNil: [^self].
	"don't resize pane side coincident with window side - RAA 5 jul 2000"
	(growingPane perform: side) = (self innerBounds perform: side) 
		ifTrue: [^self].
	(side == #top and: [growingPane top = self panelRect top]) ifTrue: [^self].
	adjoiningPanes := paneMorphs 
				select: [:pane | pane bounds bordersOn: growingPane bounds along: side].
	limit := adjoiningPanes isEmpty 
				ifFalse: 
					[(adjoiningPanes collect: [:pane | pane bounds perform: side]) 
						perform: ((#(#top #left) includes: side) ifTrue: [#max] ifFalse: [#min])]
				ifTrue: [self bounds perform: side].
	cursor := Cursor resizeForEdge: side.
	resizer := (NewHandleMorph new)
				sensorMode: self fastFramingOn;
				followHand: event hand
					forEachPointDo: 
						[:p | 
						localPt := self pointFromWorld: p.
						newBounds := growingPane bounds 
									withSideOrCorner: side
									setToPoint: localPt
									minExtent: 40 @ 20
									limit: limit.
						self fastFramingOn 
							ifTrue: 
								["For fast display, only higlight the rectangle during loop"

								Cursor currentCursor == cursor 
									ifFalse: 
										[(event hand)
											visible: false;
											refreshWorld;
											visible: true.
										cursor show].
								newBounds := growingPane bounds newRectButtonPressedDo: 
												[:f | 
												growingPane bounds 
													withSideOrCorner: side
													setToPoint: (self pointFromWorld: Sensor cursorPoint)
													minExtent: 40 @ 20
													limit: limit].].
								self 
									reframePanesAdjoining: growingPane
									along: side
									to: newBounds.
]
					lastPointDo: [:p | ]
					withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SystemWindow methodsFor: '*LookEnhancements-override' stamp: 'ar 8/18/2001 00:57'!
spawnReframeHandle: event
	"The mouse has crossed a pane border.  Spawn a reframe handle."
	| resizer localPt pt ptName newBounds cursor |
	allowReframeHandles ifFalse: [^ self].
	owner ifNil: [^ self  "Spurious mouseLeave due to delete"].
	(self isActive not or: [self isCollapsed]) ifTrue:  [^ self].
	((self world ifNil: [^ self]) firstSubmorph isKindOf: NewHandleMorph) ifTrue:
		[^ self  "Prevent multiple handles"].
	pt _ event cursorPoint.
	"prevent spurios mouse leave when dropping morphs"
	owner morphsInFrontOf: self overlapping: (pt-2 extent: 4@4)
		do:[:m| m isHandMorph ifFalse:[(m fullContainsPoint: pt) ifTrue:[^self]]].
	self bounds forPoint: pt closestSideDistLen:
		[:side :dist :len |  "Check for window side adjust"
		dist <= 2  ifTrue: [ptName _ side]].
	ptName ifNil:
		["Check for pane border adjust"
		^ self spawnPaneFrameHandle: event].
	#(topLeft bottomRight bottomLeft topRight) do:
		[:corner |  "Check for window corner adjust"
		(pt dist: (self bounds perform: corner)) < 20 ifTrue: [ptName _ corner]].

	cursor _ Cursor resizeForEdge: ptName.
	resizer _ NewHandleMorph new
		sensorMode: self fastFramingOn;

		followHand: event hand
		forEachPointDo:
			[:p | localPt _ self pointFromWorld: p.
			newBounds _ self bounds
				withSideOrCorner: ptName
				setToPoint: localPt
				minExtent: self minimumExtent.
			self fastFramingOn 
			ifTrue:
				[Cursor currentCursor == cursor ifFalse:[
					event hand visible: false; refreshWorld; visible: true.
					cursor show].
				self doFastWindowReframe: ptName]
			ifFalse:
				[self bounds: newBounds.
				(Preferences roundedWindowCorners
					and: [#(bottom right bottomRight) includes: ptName])
					ifTrue:
					["Complete kluge: causes rounded corners to get painted correctly,
					in spite of not working with top-down displayWorld."
					ptName = #bottom ifFalse:
						[self invalidRect: (self bounds topRight - (6@0) extent: 7@7)].
					ptName = #right ifFalse:
						[self invalidRect: (self bounds bottomLeft - (0@6) extent: 7@7)].
					self invalidRect: (self bounds bottomRight - (6@6) extent: 7@7)]]]
		lastPointDo:
			[:p | ]
		withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!BorderStyle class methodsFor: '*LookEnhancements' stamp: 'rr 6/21/2005 13:50'!
thinGray
	^ self width: 1 color: Color gray! !

!NewParagraph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/19/2005 17:18'!
selectionColor
	| color |
	Display depth = 1 ifTrue: [^ Color veryLightGray].
	Display depth = 2 ifTrue: [^ Color gray].
	color := Preferences textHighlightColor.
	self focused ifFalse:
		[color := color 
			alphaMixed: 0.2 
			with: 
				(Preferences inverteBright 
					ifTrue: [ Color gray twiceDarker ]
					ifFalse: [ Color veryVeryLightGray ]) ].
	^ color! !

!SimpleServiceEntry methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:24'!
buttonToTriggerIn: aFileList
	"Answer a button that will trigger the receiver service in a file list"

	| aButton |
	aButton _  PluggableButtonMorph
					on: self
					getState: nil
					action: #performServiceFor:.
	aButton 
		arguments: { aFileList }.
	aButton
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: BorderStyle thinGray;
		label: self buttonLabel;
		askBeforeChanging: true;
		onColor: Color gray offColor: Color gray.
		aButton setBalloonText: self description.

	^ aButton! !

Morph subclass: #AbstractResizerMorph
	instanceVariableNames: 'dotColor handleColor lastMouse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LookEnhancements-Extra'!

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:36'!
dotColor

	^ dotColor ifNil: [self setDefaultColors. dotColor]! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:35'!
handleColor

	^ handleColor ifNil: [self setDefaultColors. handleColor]! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:37'!
handlesMouseDown: anEvent

	^ true! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:37'!
handlesMouseOver: anEvent

	^ true
	! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:46'!
initialize

	super initialize.

	self color: Color transparent! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:40'!
isCursorOverHandle

	^ true! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:42'!
mouseDown: anEvent

	lastMouse _ anEvent cursorPoint! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:37'!
mouseEnter: anEvent

	self isCursorOverHandle ifTrue:
		[self setInverseColors.
		self changed.
		anEvent hand showTemporaryCursor: self resizeCursor]! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:37'!
mouseLeave: anEvent

	anEvent hand showTemporaryCursor: nil.
	self setDefaultColors.
	self changed! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:37'!
resizeCursor

	self subclassResponsibility! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:40'!
setDefaultColors

	handleColor _ Color lightGray lighter.
	dotColor _ Color gray! !

!AbstractResizerMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:41'!
setInverseColors

	handleColor _ Color darkGray.
	dotColor _ Color white! !

AbstractResizerMorph subclass: #CornerGripMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LookEnhancements-Extra'!

!CornerGripMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/22/2005 21:24'!
drawOn: aCanvas

	| dotBounds alphaCanvas |
	super drawOn: aCanvas.
	SystemWindow resizeOnAllSides ifFalse:
	[bounds _ self bounds.
	alphaCanvas _ aCanvas asAlphaBlendingCanvas: 0.5.	
	dotBounds _ Rectangle
		center: bounds corner - (14 @ 3)
		extent: 20 @ 4.
	alphaCanvas
		fillRectangle: dotBounds
		color: self handleColor.

	dotBounds _ Rectangle
		center: bounds corner - (3 @ 3)
		extent: 2 @ 2.
	alphaCanvas
		fillRectangle: dotBounds
		color: self handleColor.
		
	dotBounds _ Rectangle
		center: bounds corner - (3 @ 14)
		extent: 4 @ 20.
	alphaCanvas
		fillRectangle: dotBounds
		color: self handleColor..

	dotBounds _ Rectangle center: bounds corner - (14 @ 3) extent: 6 @ 4.
	alphaCanvas
		fillRectangle: dotBounds
		color: self dotColor.

	dotBounds _ Rectangle center: bounds corner - (3 @ 14) extent: 4 @ 6.
	alphaCanvas
		fillRectangle: dotBounds
		color: self dotColor]! !

!CornerGripMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:46'!
initialize

	super initialize.
	self extent: 24 @ 24
	! !

!CornerGripMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 14:43'!
mouseMove: anEvent

	| delta oldBounds |
	target ifNil: [^ self].
	
	delta _ anEvent cursorPoint - lastMouse.
	lastMouse _ anEvent cursorPoint.
	
	oldBounds _ target bounds.
	target bounds: (oldBounds origin corner: (oldBounds corner + delta)).
	
	self bounds: (self bounds origin + delta extent: self bounds extent).! !

!CornerGripMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 14:39'!
resizeCursor

	^ Cursor resizeForEdge: #bottomRight! !

!CornerGripMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 14:38'!
target: aMorph

	target _ aMorph! !

AbstractResizerMorph subclass: #ProportionalSplitterMorph
	instanceVariableNames: 'leftOrTop rightOrBottom splitsTopAndBottom oldColor traceMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LookEnhancements-Extra'!

!ProportionalSplitterMorph class methodsFor: 'preferences' stamp: 'jrp 7/8/2005 21:42'!
fastSplitterResize
	
	^ Preferences valueOfPreference: #fastSplitterResize ifAbsent: [true]! !

!ProportionalSplitterMorph class methodsFor: 'as yet unclassified' stamp: 'jrp 7/22/2005 21:10'!
initialize

	Preferences
		addPreference: #showSplitterHandles
		category: #windows
		default: true
		balloonHelp: 'When this feature is turned on it will show handles on the splitter between panes. Resizing the panes will require you to grab the handles. If not enabled then the entire splitter can be used to resize and no handles will be displayed'.

	Preferences
		addPreference: #fastSplitterResize
		category: #windows
		default: false
		balloonHelp: 'When this feature is turned on it will speed up the resizing of panes when using the splitter by eliminating the animation of pane size modifications'.

	Preferences
		addPreference: #resizeOnAllSides
		category: #windows
		default: false
		balloonHelp: 'When this feature is turned on it will allow windows to be resized on on sides. If not enabled then the resizing of windows will only be accessible from the bottom right corner'! !

!ProportionalSplitterMorph class methodsFor: 'preferences' stamp: 'jrp 7/9/2005 17:43'!
showSplitterHandles

	^ Preferences valueOfPreference: #showSplitterHandles ifAbsent: [true]! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 16:57'!
addLeftOrTop: aMorph

	leftOrTop add: aMorph! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 16:55'!
addRightOrBottom: aMorph

	rightOrBottom add: aMorph.
	
	! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 16:39'!
beSplitsTopAndBottom

	splitsTopAndBottom _ true.
	! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/9/2005 17:44'!
drawOn: aCanvas 
	| dotBounds size alphaCanvas dotSize |
	super drawOn: aCanvas.
	self class showSplitterHandles ifTrue: [
	size _ self splitsTopAndBottom
				ifTrue: [self handleSize transposed]
				ifFalse: [self handleSize].
	dotSize _ self splitsTopAndBottom
				ifTrue: [6 @ 4]
				ifFalse: [4 @ 6].
	alphaCanvas _ aCanvas asAlphaBlendingCanvas: 0.5.
	dotBounds _ Rectangle center: self bounds center extent: size.
	alphaCanvas fillRectangle: dotBounds color: self handleColor.
	dotBounds _ Rectangle center: self bounds center extent: dotSize.
	alphaCanvas fillRectangle: dotBounds color: self dotColor]! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'apl 7/8/2005 13:38'!
getOldColor
	^ oldColor ifNil: [Color transparent]! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/4/2005 10:50'!
handleRect

	^ Rectangle
		center: self bounds center 
		extent: (self splitsTopAndBottom
			ifTrue: [self handleSize transposed] 
			ifFalse: [self handleSize])! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:19'!
handleSize

	^ 4 @ 30! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/5/2005 21:46'!
initialize

	super initialize.
	
	self hResizing: #spaceFill.
	self vResizing: #spaceFill.
	splitsTopAndBottom _ false.
	
	leftOrTop _ OrderedCollection new.
	rightOrBottom _ OrderedCollection new! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/9/2005 17:44'!
isCursorOverHandle
	^ self class showSplitterHandles not or: [self handleRect containsPoint: ActiveHand cursorPoint]! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/9/2005 17:44'!
mouseDown: anEvent 
	(self class showSplitterHandles not
			and: [self bounds containsPoint: anEvent cursorPoint])
		ifTrue: [oldColor _ self color.
			self color: Color black].
	^ super mouseDown: anEvent ! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/8/2005 21:42'!
mouseMove: anEvent 
	anEvent hand temporaryCursor
		ifNil: [^ self].
	self class fastSplitterResize
		ifFalse:  [self updateFromEvent: anEvent]
		ifTrue: [traceMorph
				ifNil: [traceMorph _ Morph newBounds: self bounds.
					traceMorph borderColor: Color lightGray.
					traceMorph borderWidth: 1.
					self owner addMorph: traceMorph].
			splitsTopAndBottom
				ifTrue: [traceMorph position: traceMorph position x @ anEvent cursorPoint y]
				ifFalse: [traceMorph position: anEvent cursorPoint x @ traceMorph position y]]! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'jrp 7/8/2005 21:42'!
mouseUp: anEvent 
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph _ nil].
	self color: self getOldColor! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 16:39'!
resizeCursor

	^ Cursor resizeForEdge: (splitsTopAndBottom
		ifTrue: [#top]
		ifFalse: [#left])
		! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 17:25'!
splitsTopAndBottom

	^ splitsTopAndBottom! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'apl 7/8/2005 13:46'!
updateFromEvent: anEvent 
	| delta firstRight firstBottom secondLeft secondTop selfTop selfBottom selfLeft selfRight |
	delta := splitsTopAndBottom
				ifTrue: [0 @ (anEvent cursorPoint y - lastMouse y)]
				ifFalse: [anEvent cursorPoint x - lastMouse x @ 0].
	lastMouse := anEvent cursorPoint.
	leftOrTop
				do: [:each | 
					firstRight := each layoutFrame rightOffset
								ifNil: [0].
					firstBottom := each layoutFrame bottomOffset
								ifNil: [0].
					each layoutFrame rightOffset: firstRight + delta x.
					each layoutFrame bottomOffset: firstBottom + delta y].
			rightOrBottom
				do: [:each | 
					secondLeft := each layoutFrame leftOffset
								ifNil: [0].
					secondTop := each layoutFrame topOffset
								ifNil: [0].
					each layoutFrame leftOffset: secondLeft + delta x.
					each layoutFrame topOffset: secondTop + delta y].
	selfTop := self layoutFrame topOffset
				ifNil: [0].
	selfBottom := self layoutFrame bottomOffset
				ifNil: [0].
	selfLeft := self layoutFrame leftOffset
				ifNil: [0].
	selfRight := self layoutFrame rightOffset
				ifNil: [0].
	self layoutFrame topOffset: selfTop + delta y.
	self layoutFrame bottomOffset: selfBottom + delta y.
	self layoutFrame leftOffset: selfLeft + delta x.
	self layoutFrame rightOffset: selfRight + delta x.
	self owner layoutChanged! !

!ProportionalSplitterMorph methodsFor: 'as yet unclassified' stamp: 'bvs 3/24/2004 16:39'!
wantsEveryMouseMove

	^ true! !

!Morph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/21/2005 17:33'!
flash
	| c w |
	c _ self color.
	c = Color red
		ifTrue: [ self color: Color black ]
		ifFalse: [ self color: Color red ].
	(w _ self world) ifNotNil: [w displayWorldSafely].
	self color: c! !

!StringMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:09'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Preferences defaultTextColor! !

!Preferences class methodsFor: '*LookEnhancements' stamp: 'cmm 7/19/2005 17:18'!
defaultBackgroundColor
	^ self inverteBright
		ifTrue: [ Color black ]
		ifFalse: [ Color white ]! !

!Preferences class methodsFor: '*LookEnhancements' stamp: 'cmm 7/19/2005 17:18'!
defaultTextColor
	^ self inverteBright
		ifTrue: [ Color white ]
		ifFalse: [ Color black ]! !

!Preferences class methodsFor: '*LookEnhancements' stamp: 'cmm 7/24/2005 22:34'!
inverteBright
	^ self
		valueOfFlag: #invertBright
		ifAbsent: [false]! !

!Preferences class methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/19/2005 10:55'!
menuColor
	Display depth <= 2 ifTrue: [^ self defaultBackgroundColor ].
	^ Parameters at: #menuColor! !

!Preferences class methodsFor: '*LookEnhancements' stamp: 'jrp 7/9/2005 18:51'!
preferencesControlPanel
	"Answer a Preferences control panel window"

	"Preferences preferencesControlPanel openInHand"
	| window playfield aPanel |

	aPanel _ PreferencesPanel new.
	playfield _ PasteUpMorph new width: 385.
	playfield dropEnabled: false.
	window _ (SystemWindow labelled: 'Preferences') model: aPanel.
	self initializePreferencePanel: aPanel in: playfield.
	window on: #keyStroke send: #keyStroke: to: aPanel.
	window bounds: (100 @ 100 - (0 @ window labelHeight + window borderWidth) extent: playfield extent + (2 * window borderWidth)).
	window addMorph: playfield frame: (0 @ 0 extent: 1 @ 1).
	window updatePaneColors.
	window setProperty: #minimumExtent toValue: playfield extent + (12@15).
	^ window! !

!FillInTheBlankMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 20:37'!
createAcceptButton
	"create the [accept] button"
	| result frame |
	result _ SimpleButtonMorph new target: self;
				 color: Color lightGreen;
				useSquareCorners.
	result
		borderColor: (Preferences menuAppearance3d
				ifTrue: [#raised]
				ifFalse: [result color twiceDarker]).
	result label: 'Accept(s)' translated;
		 actionSelector: #accept.
	result setNameTo: 'accept'.
	frame _ LayoutFrame new.
	frame rightFraction: 0.5;
		 rightOffset: -10;
		 bottomFraction: 1.0;
		 bottomOffset: -2.
	result layoutFrame: frame.
	self addMorph: result.
	self
		updateColor: result
		color: result color
		intensity: 2.
	^ result! !

!FillInTheBlankMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 20:38'!
createCancelButton
	"create the [cancel] button"
	| result frame |
	result _ SimpleButtonMorph new target: self;
				 color: Color lightRed;
				useSquareCorners.
	result
		borderColor: (Preferences menuAppearance3d
				ifTrue: [#raised]
				ifFalse: [result color twiceDarker]).
	result label: 'Cancel(l)' translated;
		 actionSelector: #cancel.
	result setNameTo: 'cancel'.
	frame _ LayoutFrame new.
	frame leftFraction: 0.5;
		 leftOffset: 10;
		 bottomFraction: 1.0;
		 bottomOffset: -2.
	result layoutFrame: frame.
	self addMorph: result.
	self
		updateColor: result
		color: result color
		intensity: 2.
	^ result! !

!FillInTheBlankMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 21:42'!
extent: aPoint 
	"change the receiver's extent"

	super extent: aPoint .
	self setDefaultParameters.
	self updateColor! !

!FillInTheBlankMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 20:43'!
setDefaultParameters
	"change the receiver's appareance parameters"
	| colorFromMenu worldColor menuColor |
	colorFromMenu _ Preferences menuColorFromWorld
				and: [Display depth > 4]
				and: [(worldColor _ self currentWorld color) isColor].
	menuColor _ colorFromMenu
				ifTrue: [worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.85 with: Color black]
						ifFalse: [worldColor mixed: 0.4 with: Color white]]
				ifFalse: [Preferences menuColor].

	self color: menuColor.
	self borderStyle: BorderStyle thinGray.
	self addDropShadow;
		shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
		shadowOffset: 1@1.
	self layoutInset: 3! !

!FillInTheBlankMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/6/2005 21:44'!
updateColor: aMorph color: aColor intensity: anInteger 
	"update the apareance of aMorph"
	| fill |
	Preferences gradientMenu
		ifFalse: [^ self].

	fill _ GradientFillStyle ramp: {0.0 -> Color white. 1 -> aColor}.
	fill radial: false;
		origin: aMorph topLeft;
		direction: 0 @ aMorph height.
	aMorph fillStyle: fill! !

!ThreePhaseButtonMorph class methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 13:52'!
initialize
	"ThreePhaseButtonMorph initialize"
	| extent inset |
	extent _ 12@12.
	inset _ 3.

	#('CheckBoxOff' 'CheckBoxOn' 'CheckBoxPressed') do: [:button |
		| f r |
		f _ ColorForm extent: extent depth: 1.
		f colors: {Color white. Color black}.
		f borderWidth: 1.
		r _ f boundingBox insetBy: inset.
		button = 'CheckBoxPressed' ifTrue: [f border: r width: 1].
		button = 'CheckBoxOn' ifTrue: [f fillBlack: r].
		ScriptingSystem saveForm: f atKey: button].

	#('RadioButtonOff' 'RadioButtonOn' 'RadioButtonPressed') do: [:button |
		| f r c |
		f _ ColorForm extent: extent depth: 1.
		f colors: {Color white. Color black}.
		r _ f boundingBox.
		c _ f getCanvas.
		c frameOval: r color: Color black.
		r _ r insetBy: inset.
		button = 'RadioButtonPressed' ifTrue:
			[c frameOval: r color: Color black].
		button = 'RadioButtonOn' ifTrue:
			[c fillOval: r color: Color black].
		ScriptingSystem saveForm: f atKey: button]! !

!Browser methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 13:23'!
addAListPane: aListPane to: window at: nominalFractions plus: verticalOffset

	| row switchHeight divider |

	row _ AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 1;
		borderWidth: 1;
		layoutPolicy: ProportionalLayout new.
	switchHeight _ 25.
	self 
		addMorphicSwitchesTo: row 
		at: (
			LayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (0@(1-switchHeight)  corner: 0@0)
		).

	divider _ BorderedSubpaneDividerMorph forTopEdge.
	Preferences alternativeWindowLook ifTrue:[
		divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 0.
	].
	row 
		addMorph: divider
		fullFrame: (
			LayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (0@switchHeight negated corner: 0@(1-switchHeight))
		).	

	row 
		addMorph: aListPane
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@0 corner: 0@(switchHeight negated))
		).	

	window 
		addMorph: row
		fullFrame: (
			LayoutFrame 
				fractions: nominalFractions 
				offsets: (0@verticalOffset corner: 0@0)
		).	
	row on: #mouseEnter send: #paneTransition: to: window.
	row on: #mouseLeave send: #paneTransition: to: window.

! !

!Browser methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 13:24'!
addMorphicSwitchesTo: window at: aLayoutFrame

	window 
		addMorph: self buildMorphicSwitches
		fullFrame: aLayoutFrame.

! !

!Browser methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:11'!
buildMorphicSwitches

	| instanceSwitch commentSwitch classSwitch row aColor |

	instanceSwitch _ PluggableButtonMorph
		on: self
		getState: #instanceMessagesIndicated
		action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true;
		borderWidth: 1;
		borderColor: Color gray.
	commentSwitch _ PluggableButtonMorph
		on: self
		getState: #classCommentIndicated
		action: #plusButtonHit.
		
	commentSwitch
		label: '?' asText allBold;
		askBeforeChanging: true;
		setBalloonText: 'class comment';
		borderWidth: 1;
		borderColor: Color gray.
	classSwitch _ PluggableButtonMorph
		on: self
		getState: #classMessagesIndicated
		action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true;
		borderWidth: 1;
		borderColor: Color gray.
	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellInset: 1;
		borderWidth: 0;
		addMorphBack: instanceSwitch;
		addMorphBack: commentSwitch;
		addMorphBack: classSwitch.

	aColor _ Preferences inverteBright 
		ifTrue: [ Color green muchDarker ]
		ifFalse: [ Color green muchLighter ].
	row color: aColor.
	{instanceSwitch. commentSwitch. classSwitch} do: [:m | 
		m 
			color: aColor;
			onColor: aColor offColor: Preferences defaultBackgroundColor ;
			hResizing: #spaceFill;
			vResizing: #spaceFill.].
	^ row
! !

!Debugger methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 14:43'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset 
	"Add button panes to the window. A row of custom
	debugger-specific buttons (Proceed, Restart, etc.) is always
	added, and if optionalButtons is in force, then the standard
	code-tool buttons are also added. Answer the verticalOffset
	plus the height added."
	| delta buttons anOffset |
	anOffset := (Preferences optionalButtons
					and: [Preferences extraDebuggerButtons])
				ifTrue: [super
						addOptionalButtonsTo: window
						at: fractions
						plus: verticalOffset]
				ifFalse: [verticalOffset].
	delta := self defaultButtonPaneHeight.
	buttons := self customButtonRow.
	buttons
		color: (Display depth <= 8
				ifTrue: [Color transparent]
				ifFalse: [Color gray alpha: 0.2]);
		 borderWidth: 0.
	Preferences alternativeWindowLook
		ifTrue: [buttons color: Color white].
	window
		addMorph: buttons
		fullFrame: (LayoutFrame
				fractions: fractions
				offsets: (0 @ anOffset corner: 0 @ (anOffset + delta - 1))).
	^ anOffset + delta! !

!Debugger methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/2/2005 13:34'!
buildMorphicNotifierLabelled: label message: messageString
	| notifyPane window contentTop extentToUse |
	self expandStack.
	window _ (PreDebugWindow labelled: label) model: self.

	contentTop _ 0.25.
	extentToUse _ 450 @ 156. "nice and wide to show plenty of the error msg"
	window addMorph: (self buttonRowForPreDebugWindow: window)
				frame: (0@0 corner: 1 @ contentTop).

	Preferences eToyFriendly | messageString notNil
		ifFalse:
			[notifyPane _ PluggableListMorph on: self list: #contextStackList
				selected: #contextStackIndex changeSelected: #debugAt:
				menu: nil keystroke: nil]
		ifTrue:
			[notifyPane _ PluggableTextMorph on: self text: nil accept: nil
				readSelection: nil menu: #debugProceedMenu:.
			notifyPane editString: (self preDebugNotifierContentsFrom: messageString);
				askBeforeDiscardingEdits: false].

	window addMorph: notifyPane frame: (0@contentTop corner: 1@1).
	"window deleteCloseBox.
		chickened out by commenting the above line out, sw 8/14/2000 12:54"
	window setBalloonTextForCloseBox.

	^ window openInWorldExtent: extentToUse! !

!Debugger methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/2/2005 13:33'!
buttonRowForPreDebugWindow: aDebugWindow
	| aRow aButton quads |
	aRow _ AlignmentMorph newRow hResizing: #spaceFill; vResizing: #spaceFill.
	aRow layoutInset: 1; cellInset: 1.
	aRow beSticky.
	aRow addMorphBack: AlignmentMorph newVariableTransparentSpacer.
	quads _ OrderedCollection withAll: self preDebugButtonQuads.
	(self interruptedContext selector == #doesNotUnderstand:) ifTrue: [
		quads add: { 'Create'. #createMethod. #magenta. 'create the missing method' }
	].
	quads do:
			[:quad |
				aButton _ SimpleButtonMorph new target: aDebugWindow.
				aButton color: Color white; borderWidth: 1.
				aButton actionSelector: quad second.
				aButton label: quad first.
				aButton submorphs first color: (Color colorFrom: quad third).
				aButton setBalloonText: quad fourth.
				Preferences alternativeWindowLook 
					ifTrue:[aButton borderStyle: BorderStyle thinGray].
				aButton useSquareCorners.
				aRow addMorphBack: aButton.
				aRow addMorphBack: AlignmentMorph newVariableTransparentSpacer].
	^ aRow! !

!Debugger methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:15'!
customButtonRow
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'customButtonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| aRow aButton aLabel |
	aRow _ AlignmentMorph newRow beSticky.
	aRow setNameTo: 'customButtonPane'.
	aRow clipSubmorphs: true.
	aButton _ SimpleButtonMorph new target: self.
	aButton color: Color lightRed; borderWidth: 1; borderColor: Color red darker.
	aRow addTransparentSpacerOfSize: (5@0).
	self customButtonSpecs do:
		[:tuple |
			aButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: tuple second.
			aButton
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				borderStyle: BorderStyle thinGray;
				onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.
			(#(proceed restart send doStep stepIntoBlock fullStack where) includes: tuple second)
				ifTrue:
					[aButton askBeforeChanging: true].

			aLabel _ Preferences abbreviatedBrowserButtons 
				ifTrue: [self abbreviatedWordingFor: tuple second]
				ifFalse: [nil].
			aButton label: (aLabel ifNil: [tuple first asString]).

			tuple size > 2 ifTrue: [aButton setBalloonText: tuple third].
			aRow addMorphBack: aButton.
			aRow addTransparentSpacerOfSize: (3 @ 0)].
	^ aRow! !

!Debugger methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:15'!
optionalButtonRow
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'buttonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| aRow aButton aLabel |
	aRow _ AlignmentMorph newRow beSticky.
	aRow setNameTo: 'buttonPane'.
	aRow clipSubmorphs: true.
	aButton _ SimpleButtonMorph new target: self.
	aButton color: Color lightRed; borderWidth: 1; borderColor: Color red darker.
	aRow addTransparentSpacerOfSize: (5@0).
	self optionalButtonPairs do:
		[:tuple |
				aButton _ PluggableButtonMorph
					on: self
					getState: nil
					action: tuple second.
				aButton
					hResizing: #spaceFill;
					vResizing: #spaceFill;
					borderStyle: BorderStyle thinGray;
					onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.
				(#(proceed restart send doStep stepIntoBlock fullStack where) includes: tuple second)
					ifTrue:
						[aButton askBeforeChanging: true].

				aLabel _ Preferences abbreviatedBrowserButtons 
					ifTrue: [self abbreviatedWordingFor: tuple second]
					ifFalse: [nil].
				aButton label: (aLabel ifNil: [tuple first asString]).

				tuple size > 2 ifTrue: [aButton setBalloonText: tuple third].
				aRow addMorphBack: aButton.
				aRow addTransparentSpacerOfSize: (3 @ 0)].
	^ aRow! !

!TextMorphForEditView methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:10'!
initialize
	super initialize.
	acceptOnCR _ false.
	self color: Preferences defaultTextColor! !

!IndentingListItemMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 15:26'!
drawOn: aCanvas

	| tRect sRect columnRect columnScanner columnData columnLeft colorToUse |

	tRect := self toggleRectangle.
	sRect := bounds withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	colorToUse _ Preferences defaultTextColor.
	container selectedMorph = self ifTrue: [ aCanvas fillRectangle: sRect color: Preferences textHighlightColor ].
	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: colorToUse.
	] ifFalse: [
		columnLeft _ sRect left.
		columnScanner _ ReadStream on: contents asString.
		container columns do: [ :width |
			columnRect _ columnLeft @ sRect top extent: width @ sRect height.
			columnData _ columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: colorToUse.
			].
			columnLeft _ columnRect right + 5.
		].
	]
! !

!IndentingListItemMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 22:51'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	container _ hostList.
	complexContents _ anObject.
	self initWithContents: anObject asString font: Preferences standardListFont emphasis: nil.
	self color: Preferences defaultTextColor.
	indentLevel _ 0.
	isExpanded _ false.
 	nextSibling _ firstChild _ nil.
	priorMorph ifNotNil: [
		priorMorph nextSibling: self.
	].
	indentLevel _ newLevel.
! !

!IndentingListItemMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 22:53'!
unhighlight

	complexContents highlightingColor ifNotNil:
		[ self color: Preferences defaultTextColor ].
	self changed.
! !

!PluggableListMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:05'!
textColor
	"Answer my default text color."
	^ self 
		valueOfProperty: #textColor 
		ifAbsent: [ Preferences defaultTextColor ]! !

!PluggableListMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:07'!
textHighlightColor
	"Answer my default text highlight color."
	^ Preferences textHighlightColor! !

!IconicButton methodsFor: '*LookEnhancements' stamp: 'jrp 7/5/2005 23:15'!
mouseEnter: evt

	self borderStyle: BorderStyle thinGray! !

!IconicButton methodsFor: '*LookEnhancements' stamp: 'jrp 7/5/2005 22:50'!
mouseLeave: evt

	self borderNormal! !

!MCTool methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:05'!
buttonRow: specArray
	| aRow aButton state |
	aRow _ AlignmentMorph newRow.
	aRow 
		color: (Display depth <= 8 ifTrue: [Color transparent] ifFalse: [Color gray alpha: 0.2]);
		borderWidth: 0.

	aRow hResizing: #spaceFill; vResizing: #spaceFill; rubberBandCells: true.
	aRow clipSubmorphs: true.
	aRow layoutInset:2@2; cellInset: 1; color: Color white.
	aRow wrapCentering: #center; cellPositioning: #leftCenter.
	specArray do:
		[:triplet |
			state _ triplet at: 4 ifAbsent: [#buttonState].
			aButton _ PluggableButtonMorph
				on: self
				getState: state
				action: #performButtonAction:enabled:.
			aButton
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				borderStyle: BorderStyle thinGray;
				label: triplet first asString;
				arguments: (Array with: triplet second with: state); 
				onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.
			aRow addMorphBack: aButton.
			aButton setBalloonText: triplet third].

	^ aRow! !

!BrowserCommentTextMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 10/3/2004 18:40'!
hidePane
	| win |
	self window ifNotNilDo: [:window | window removePaneSplitters].
	
	self lowerPane ifNotNilDo:
		[ :lp | 
		lp layoutFrame bottomFraction: self layoutFrame bottomFraction.
		lp layoutFrame bottomOffset: -6].
	win _ self window ifNil: [ ^self ].
	self delete.
	win updatePanesFromSubmorphs.
	win addPaneSplitters! !

!BrowserCommentTextMorph methodsFor: '*LookEnhancements-override' stamp: 'jrp 10/3/2004 18:39'!
showPane
	owner ifNil: [
		| win |
		win _ self window ifNil: [ ^self ].
		win addMorph: self fullFrame: self layoutFrame.
		win updatePanesFromSubmorphs ].

	self lowerPane ifNotNilDo: [ :lp | lp layoutFrame bottomFraction: self layoutFrame topFraction ].
	
	self window ifNotNilDo: [:win | win addPaneSplitters]! !

!BooleanPreferenceView methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/19/2005 17:02'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"

	| outerButton aButton str miniWrapper |
	
	outerButton := AlignmentMorph newRow height: 24.
	outerButton color:  (aColor ifNil: [Color r: 0.645 g: 1.0 b: 1.0]).
	outerButton hResizing: (aPreferencesPanel ifNil: [#shrinkWrap] ifNotNil: [#spaceFill]).
	outerButton vResizing: #shrinkWrap.
	outerButton addMorph: (aButton := UpdatingThreePhaseButtonMorph checkBox).
	aButton
		target: self preference;
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue.

	outerButton addTransparentSpacerOfSize: (2 @ 0).
	str := StringMorph contents: self preference name font: (StrikeFont familyName: 'NewYork' size: 12).
	str color: Preferences defaultTextColor.
	self preference localToProject ifTrue:
		[str emphasis: 1].

	miniWrapper := AlignmentMorph newRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	miniWrapper beTransparent addMorphBack: str lock.
	aPreferencesPanel
		ifNotNil:  "We're in a Preferences panel"
			[miniWrapper on: #mouseDown send: #offerPreferenceNameMenu:with:in: to: self withValue: aPreferencesPanel.
			miniWrapper on: #mouseEnter send: #menuButtonMouseEnter: to: miniWrapper.
			miniWrapper on: #mouseLeave send: #menuButtonMouseLeave: to: miniWrapper.
			miniWrapper setBalloonText: 'Click here for a menu of options regarding this preference.  Click on the checkbox to the left to toggle the setting of this preference']

		ifNil:  "We're a naked button, not in a panel"
			[miniWrapper setBalloonText: self preference helpString; setProperty: #balloonTarget toValue: aButton].

	outerButton addMorphBack: miniWrapper.
	outerButton setNameTo: self preference name.

	aButton setBalloonText: self preference helpString.

	^ outerButton

	"(Preferences preferenceAt: #balloonHelpEnabled) view tearOffButton"! !

!MCSaveVersionDialog methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/2/2005 10:33'!
widgetSpecs
	^ #(	
		((textMorph: versionName) (0 0 1 0) (0 0 0 30))
		((textMorph: logMessage) (0 0 1 1) (0 30 0 -30))
		((buttonRow) (0 1 1 1) (0 -40 0 0))
		)! !

!SimpleButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/3/2005 18:06'!
handlesMouseOverDragging: evt

	^ true! !

!SimpleButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/2/2005 13:31'!
handlesMouseOver: evt

	^ true! !

!SimpleButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/2/2005 13:31'!
mouseEnter: evt

	"0.09375 is exact in floating point so no cumulative rounding error will occur"
	self color: (self color adjustBrightness: -0.09375)! !

!SimpleButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/3/2005 18:06'!
mouseLeaveDragging: evt

	self mouseLeave: evt! !

!SimpleButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/3/2005 17:56'!
mouseLeave: evt

	"0.09375 is exact in floating point so no cumulative rounding error will occur"
	self color: (self color adjustBrightness: 0.09375)! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 13:58'!
buildLowerPanes
	| failuresList errorsList row tHeight divider |
	row _ AlignmentMorph newColumn hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 layoutInset: 0;
				 borderWidth: 1;
				 borderColor: Color black;
				 layoutPolicy: ProportionalLayout new.
	self buildPassFailText.
	self buildDetailsText.
	self buildTestsList.
	failuresList _ self buildFailuresList.
	errorsList _ self buildErrorsList.
	tHeight _ 26.
	divider _ Array new: 3.
	1
		to: divider size
		do: [:index | 
			divider at: index put: BorderedSubpaneDividerMorph forBottomEdge.
			Preferences alternativeWindowLook
				ifTrue: [(divider at: index) extent: 4 @ 4;
						 color: Color gray;
						 borderColor: #raised;
						 borderWidth: 0]].
	row
		addMorph: (passFailText borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ tHeight - 1)).
	row
		addMorph: (divider at: 1)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (tHeight - 1) corner: 0 @ tHeight)).
	row
		addMorph: (detailsText borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ tHeight corner: 0 @ (2 * tHeight - 1))).
	row
		addMorph: (divider at: 2)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (2 * tHeight - 1) corner: 0 @ (2 * tHeight))).
	row
		addMorph: (failuresList borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0.6)
				offsets: (0 @ (2 * tHeight) corner: 0 @ -1)).
	row
		addMorph: (divider at: 3)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.6 corner: 1 @ 0.6)
				offsets: (0 @ - 1 corner: 0 @ 0)).
	row
		addMorph: (errorsList borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.6 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	^ row! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 13:56'!
buildTestsList
	| column offset buttonRow |
	column _ AlignmentMorph newColumn hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 layoutInset: 0;
				 borderWidth: 0;
				 borderColor: Color black;
				color: Color transparent;
				 layoutPolicy: ProportionalLayout new.
	testsList _ PluggableListMorphOfMany
				on: self
				list: #tests
				primarySelection: #selectedSuite
				changePrimarySelection: #selectedSuite:
				listSelection: #listSelectionAt:
				changeListSelection: #listSelectionAt:put:
				menu: #listMenu:shifted:.
	testsList autoDeselect: false.
	offset _ 0.
	self wantsOptionalButtons
		ifTrue: [offset _ TextStyle default lineGrid + 14 ].
	column
		addMorph: testsList
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ offset negated)).
	self wantsOptionalButtons
		ifTrue: [buttonRow _ self optionalButtonRow.
			buttonRow
				color: (Display depth <= 8
						ifTrue: [Color transparent]
						ifFalse: [Color gray alpha: 0.2]);
				 borderWidth: 0.
			Preferences alternativeWindowLook
				ifTrue: [buttonRow color: Color white].
				"	buttonRow
						submorphsDo: [:m | m borderWidth: 1;
								 borderColor: #raised]]."
			column
				addMorph: buttonRow
				fullFrame: (LayoutFrame
						fractions: (0 @ 1 corner: 1 @ 1)
						offsets: (0 @ (offset - 1) negated corner: 0 @ 0))].
	^ column! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 13:57'!
buildUpperControls
	| refreshButton filterButton stopButton runOneButton runButton row bWidth listsMorph |
	row _ BorderedMorph new
				hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 borderWidth: 1;
				 borderColor: Color black;
				 layoutPolicy: ProportionalLayout new.
	row
		color: (Display depth <= 8
				ifTrue: [Color transparent]
				ifFalse: [Color gray alpha: 0.2]);
		 clipSubmorphs: true;
		 cellInset: 3;
		 borderWidth: 0.
	refreshButton _ self buildRefreshButton.
	filterButton _ self buildFilterButton.
	stopButton _ self buildStopButton.
	runOneButton _ self buildRunOneButton.
	runButton _ self buildRunButton.
	listsMorph _ self buildTestsList.
	bWidth _ 90.
	row
		addMorph: refreshButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 0.33)
				offsets: (4 @ 2 corner: bWidth - 4 @ -2)).
	row
		addMorph: filterButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.33 corner: 0 @ 0.66)
				offsets: (4 @ 2 corner: bWidth - 4 @ -2)).
	row
		addMorph: stopButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.66 corner: 0 @ 1)
				offsets: (4 @ 2 corner: bWidth - 4 @ -2)).
	row
		addMorph: listsMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (bWidth  @ 0 corner: bWidth negated @ 0)).
	row
		addMorph: runOneButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 0.5)
				offsets: (bWidth negated + 4 @ 2 corner: -4 @ -2)).
	row
		addMorph: runButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 0.5 corner: 1 @ 1)
				offsets: (bWidth negated + 4 @ 2 corner: -4 @ -2)).
	Preferences alternativeWindowLook
		ifTrue: [row color: Color transparent.
			row
				submorphsDo: [:m | m borderStyle: BorderStyle thinGray.
								m useSquareCorners]].
	^ row! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/4/2005 12:10'!
morphicWindow
	"TestRunner new openAsMorph"
	| upperRow lowerPanes fracYRatio window |
	window _ SystemWindow labelled: self windowLabel.
	window model: self.
	upperRow _ self buildUpperControls.
	lowerPanes _ self buildLowerPanes.
	fracYRatio _ 0.25.
	window
		addMorph: upperRow
		fullFrame: (LayoutFrame fractions: (0 @ 0 extent: 1 @ fracYRatio) offsets: (0@0 corner: 0@0)).
	window
		addMorph: lowerPanes
		fullFrame: (LayoutFrame fractions: (0 @ fracYRatio extent: 1 @ (1 - fracYRatio)) offsets: (0@0 corner: 0@0)).
	self refreshWindow.
	window extent: 460 @ 400.
	^window! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:27'!
optionalButtonRow
	| row btn |
	row _ AlignmentMorph newRow.
	row beSticky.
	row hResizing: #spaceFill.
	row wrapCentering: #center;
		 cellPositioning: #leftCenter.
	row clipSubmorphs: true.
	row cellInset: 3.
	self optionalButtonPairs
		do: [:pair | 
		btn _ PluggableButtonMorph on: self getState: nil action: pair second.
		btn borderStyle: BorderStyle thinGray; hResizing: #spaceFill; vResizing: #spaceFill; onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor ;
		label: pair first.
		row addMorphBack: btn
		].
	^ row! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:25'!
runButtonColor

	^ Preferences inverteBright 
		ifTrue: [ Color green darker ]
		ifFalse: [ Color green lighter ]! !

!TestRunner methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:26'!
runButtonOffColor
	^ Preferences inverteBright
		ifTrue: [ Color yellow darker ]
		ifFalse: [ Color yellow lighter ]! !

!SimpleHierarchicalListMorph methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 23:08'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self lineColor: Color gray.
	self
		on: #mouseMove
		send: #mouseStillDown:onItem:
		to: self! !

!ListItemWrapper methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/18/2005 22:59'!
highlightingColor

	^ Preferences textHighlightColor! !

!PluggableButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/3/2005 18:13'!
handlesMouseOverDragging: evt

	^ true! !

!PluggableButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/2/2005 10:44'!
handlesMouseOver: evt

	^ true! !

!PluggableButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/2/2005 10:59'!
mouseEnter: evt

	"0.09375 is exact in floating point so no cumulative rounding error will occur"
	self color: (self color adjustBrightness: -0.09375)! !

!PluggableButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/3/2005 18:13'!
mouseLeaveDragging: evt

	self mouseLeave: evt! !

!PluggableButtonMorph methodsFor: '*LookEnhancements' stamp: 'jrp 7/2/2005 16:21'!
mouseLeave: evt

	"0.09375 is exact in floating point so no cumulative rounding error will occur"
	self color: (self color adjustBrightness: 0.09375).
	self update: nil! !

!CodeHolder methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:40'!
addOptionalAnnotationsTo: window at: fractions plus: verticalOffset
	"Add an annotation pane to the window if preferences indicate a desire for it, and return the incoming verticalOffset plus the height of the added pane, if any"

	| aTextMorph divider delta |
	self wantsAnnotationPane ifFalse: [^ verticalOffset].
	aTextMorph _ PluggableTextMorph 
		on: self
		text: #annotation 
		accept: nil
		readSelection: nil
		menu: #annotationPaneMenu:shifted:.
	aTextMorph
		askBeforeDiscardingEdits: false;
		borderWidth: 0;
		hideScrollBarsIndefinitely.
	divider _ BorderedSubpaneDividerMorph forBottomEdge.
	Preferences alternativeWindowLook ifTrue:[
		divider extent: 4@4; color: Color transparent; borderColor: Color gray; borderWidth: 2.
	].
	delta _ self defaultAnnotationPaneHeight.
	window 
		addMorph: aTextMorph 
		fullFrame: (LayoutFrame 
				fractions: fractions 
				offsets: (0@verticalOffset corner: 0@(verticalOffset + delta - 1))).
	window 
		addMorph: divider
		fullFrame: (LayoutFrame 
				fractions: fractions 
				offsets: (0@(verticalOffset + delta - 1) corner: 0@(verticalOffset + delta))).
	^ verticalOffset + delta! !

!CodeHolder methodsFor: '*LookEnhancements-override' stamp: 'rr 6/21/2005 13:29'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset 
	"If the receiver wishes it, add a button pane to the window, and
	answer the verticalOffset plus the height added"
	| delta buttons divider |
	self wantsOptionalButtons
		ifFalse: [^ verticalOffset].
	delta := self defaultButtonPaneHeight.
	buttons := self optionalButtonRow color: Color white.
	divider := BorderedSubpaneDividerMorph forBottomEdge.
	Preferences alternativeWindowLook
		ifTrue: [divider extent: 4 @ 4;
				 color: Color gray;
				 borderColor: #simple;
				 borderWidth: 1].
	window
		addMorph: buttons
		fullFrame: (LayoutFrame
				fractions: fractions
				offsets: (0 @ verticalOffset corner: 0 @ (verticalOffset + delta - 1))).
	window
		addMorph: divider
		fullFrame: (LayoutFrame
				fractions: fractions
				offsets: (0 @ (verticalOffset + delta - 1) corner: 0 @ (verticalOffset + delta))).
	^ verticalOffset + delta! !

!CodeHolder methodsFor: '*LookEnhancements-override' stamp: 'jrp 7/3/2005 14:29'!
codePaneProvenanceButton
	"Answer a button that reports on, and allow the user to modify,
	the code-pane-provenance setting"
	| aButton |
	aButton _ UpdatingSimpleButtonMorph newWithLabel: 'source'.
	aButton setNameTo: 'codeProvenance'.
	aButton useSquareCorners.
	aButton target: self;
		 wordingSelector: #codePaneProvenanceString;
		 actionSelector: #offerWhatToShowMenu.
	aButton setBalloonText: 'Governs what view is shown in the code pane.  Click here to change the view'.
	aButton actWhen: #buttonDown.
	aButton color: Color white;
		borderStyle: BorderStyle thinGray; vResizing: #spaceFill.
	^ aButton! !

!CodeHolder methodsFor: '*LookEnhancements-override' stamp: 'cmm 7/20/2005 14:14'!
optionalButtonRow
	"Answer a row of control buttons"
	| aRow aButton aLabel |
	aRow := AlignmentMorph newRow.
	aRow setNameTo: 'buttonPane'.
	aRow beSticky.
	aRow hResizing: #spaceFill.
	aRow wrapCentering: #center;
		 cellPositioning: #leftCenter.
	aRow clipSubmorphs: true.
	aRow cellInset: 1.
	aRow color: Color white.
	Preferences menuButtonInToolPane
		ifTrue: [aRow addMorphFront: self menuButton].
	self optionalButtonPairs
		do: [:tuple | 
			aButton := PluggableButtonMorph
						on: self
						getState: nil
						action: tuple second.
			aButton hResizing: #spaceFill;
				 vResizing: #spaceFill;
				borderStyle: BorderStyle thinGray;
				 onColor: Preferences defaultBackgroundColor offColor: Preferences defaultBackgroundColor.
			aLabel := Preferences abbreviatedBrowserButtons
						ifTrue: [self abbreviatedWordingFor: tuple second].
			aButton
				label: (aLabel
						ifNil: [tuple first asString]).
			tuple size > 2
				ifTrue: [aButton setBalloonText: tuple third].
			tuple size > 3
				ifTrue: [aButton triggerOnMouseDown: tuple fourth].
			aRow addMorphBack: aButton].
	aRow addMorphBack: self codePaneProvenanceButton.
	^ aRow! !
MenuMorph initialize!
LookEnhancementPreferences initialize!
ProportionalSplitterMorph initialize!
ThreePhaseButtonMorph initialize!
